<?php
//
// ZoneMinder (A)ctive (R)response (C)amera latest events view PHP file,
// $Date: 2013-08-30 19:52:12 +0000 (Fri, 30 Aug 2013) $, $Revision: 1 $
// Copyright (C) 2013 Anthony Cassandra
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

//========================================
// Preliminary data fetching and logic
//========================================

$eventsSql = "select E.Id,E.MonitorId,M.Name As MonitorName,E.Name,E.Cause,E.Notes,E.StartTime,E.EndTime,E.Length,E.Frames,E.AlarmFrames,E.TotScore,E.AvgScore,E.MaxScore,E.Archived from Monitors as M inner join Events as E on (M.Id = E.MonitorId) where";
if ( $user['MonitorIds'] )
{
    $eventsSql .= " M.Id in (".join( ",", preg_split( '/["\'\s]*,["\'\s]*/', $user['MonitorIds'] ) ).")";
}
else
{
  $eventsSql .= " 1";
}

$eventsSql .= " ORDER BY E.StartTime DESC LIMIT 1";

$events = array();
$firstEventId = null;
$firstEventMonitorId = null;
$firstHasEnded = null;
foreach ( dbFetchAll( $eventsSql ) as $event )
{
    $events[] = $event;
    if ( $firstEventId == null ) {
      $firstEventId = $event['Id'];
      $firstEventMonitorId = $event['MonitorId'];

      if ( $event['EndTime']
           && ! empty($event['EndTime']))
        $firstHasEnded = "true";
      else
        $firstHasEnded = "false";
    }
}

//========================================
// Beginning of page rendering
//========================================

xhtmlHeaders(__FILE__, $SLANG['Events'] );

?>

<body onload="ARC_handleEventListLatestPageLoaded('<?= $firstEventId ?>', '<?= $firstEventMonitorId ?>', '<?= $firstHasEnded ?>' );">
  <div>
    <div>
        <table>
          <tbody>

<?php

$isFirst = false;
foreach ( $events as $event )
  {
  $eventId = $event['Id'].($event['Archived']?'*':'');
  $rowElemId = "arc-event-row-".$eventId;
  
?>
            <tr id="<?= $rowElemId ?>"
                onclick="ARC_handleEventRowClick( '<?= $eventId ?>' );">
               <td><?= $eventId ?></td>
               <td><?= $event['MonitorName'] ?></td>
               <td><?= strftime( STRF_FMT_DATETIME_SHORTER, strtotime($event['StartTime']) ) ?></td>
               <td><?= $event['Length'] ?></td>
               <td><?= $event['Frames'] ?></td>
               <td><?= $event['AlarmFrames'] ?></td>
               <td><?= $event['TotScore'] ?></td>
            </tr>

<?php
}
?>

          </tbody>
        </table>

    </div>
  </div>

</body>
</html>
